/*****************************************************************************
 *
 * settings.h
 *
 * PHASEX:  [P]hase [H]armonic [A]dvanced [S]ynthesis [EX]periment
 *
 * Copyright (C) 1999-2007 William Weston <weston@sysex.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************************/
#ifndef _PHASEX_SETTINGS_H_
#define _PHASEX_SETTINGS_H_


#include <gtk/gtk.h>
#include "phasex.h"


/* typedef enum { */
/*     SETTING_TYPE_BOOL	= 0 */
/* } SETTING_TYPE; */


/* typedef enum { */
/*     SETTING_FULLSCREEN		= 0, */
/*     SETTING_JACK_CONNECT_PHYS	= 1, */
/*     SETTING_IDLE_SLEEP		= 2, */
/*     SETTING_BANK_MODE		= 3, */
/*     SETTING_ENGINE_PRIORITY	= 4, */
/*     SETTING_MIDI_PRIORITY	= 5 */
/* } SETTING_ID; */


/* typedef struct setting { */
/*     char		*name; */
/*     int			id; */
/*     SETTING_TYPE	type; */
/*     int			int_val; */
/*     char		*str_val; */

/* } SETTING; */


extern int setting_fullscreen;
extern int setting_backing_store;
extern int setting_jack_autoconnect;
extern int setting_sample_rate_mode;
extern int setting_bank_mem_mode;
extern int setting_gui_idle_sleep;
extern int setting_midi_priority;
extern int setting_engine_priority;

extern double setting_tuning_freq;

extern char *setting_midimap_file;

extern char *sample_rate_mode_names[];
extern char *bank_mem_mode_names[];


void read_settings(void);
void save_settings(void);
void set_fullscreen_mode(GtkWidget *widget, gpointer data);
void set_backing_store(GtkWidget *widget, gpointer data);
void set_gui_idle_sleep(GtkWidget *widget, gpointer data);
void set_midi_priority(GtkWidget *widget, gpointer data);
void set_engine_priority(GtkWidget *widget, gpointer data);
void set_jack_autoconnect(GtkWidget *widget, gpointer data);
void set_tuning_freq(GtkWidget *widget, gpointer data);
void set_sample_rate_mode(GtkWidget *widget, gpointer data);
void set_bank_mem_mode(GtkWidget *widget, gpointer data);
void close_config_dialog(void);
void create_config_dialog(void);


#endif /* _PHASEX_SETTINGS_H_ */
